#!/bin/bash
# текущее время
DATETIME=`date +%F_%H-%M-%S`

# где будут храниться копии резервных файлов
BACKUPDIR=/var/backups/sites/
# имя резервного файла, в который упаковываются данные
BACKUPFILE=my_$DATETIME.tar.gz

# имена сохраняемых баз
DBNAMES="mybase1 mybase2 mysql"
# имя сохраняемой копии баз данных
DBFILENAME=my_$DATETIME.tar

# исходный каталог
SRCDIR=/home/
# файлы и каталоги, записываемые в резервную копию
SRCFILES="cat1 cat2 cat3 "$DBFILENAME

# данные доступа к ФТП
FTPUSER=ftpuser
FTPPASS=ftppass
# путь для сохранения резервной копии
FTPPATH=ftp://site.ru/path/

echo "Start: [`date +%F--%H-%M`]"

# остановка mysql (чтобы можно было безболезненно сделать прямую копию)
echo "[Stopped MySQL Daemon]"
/etc/init.d/mysql stop

# сохранение копии в SRCDIR (несжатый tar)
echo "[Copy MySQL Datas]"
cd /var/lib/mysql/ && tar cpf $SRCDIR$DBFILENAME $DBNAMES && cd -

# запуск mysql
echo "[Start MySQL Daemon]"
/etc/init.d/mysql start

# здесь, в принципе, можно остановить apache
# но для меня некритична потеря нескольких записей в логах
#/etc/init.d/apache2 stop

echo "[Save Important Data]"
cd $SRCDIR && tar czpf $BACKUPDIR$BACKUPFILE $SRCFILES && cd -

# если apache был остановлен, его требуется запустить
#/etc/init.d/apache2 start

# перемещение файлов в директорию хранения резервных копий
echo "[Remove MySQL Backup-Files]"
rm $SRCDIR$DBFILENAME

# если нет стороннего фтп, следующие 2 строки можно удалить
echo "[Save Backup To Remote Host]"
curl -T $BACKUPDIR$BACKUPFILE -u $FTPUSER:$FTPPASS $FTPPATH$BACKUPFILE

echo "Stop: [`date +%F--%H-%M`]"
