#!/bin/bash

# время одного из предыдующих бекапов (составляет часть имени файла)
DATETIME=2010-09-08_07-06-05

# из какого файла восстановиться (имя бекапа: my_DATETIME.tar.gz)
FROMFILE=my_$DATETIME.tar.gz

# исходный каталог
SRCDIR=/home/

# имя сохраняемой копии баз данных
DBFILENAME=my_$DATETIME.tar

# данные доступа к ФТП
FTPUSER=ftpuser
FTPPASS=ftppass
# путь для сохранения резервной копии
FTPPATH=site.ru/path/

echo "Start: [`date +%F--%H-%M`]"

# если стороннего фтп нет, следующие 2 строки можно удалить
# в этом случае резервную копию необходимо скопировать в SRCDIR
echo "[Get Reserved Copy]"
wget -P $SRCDIR ftp://$FTPUSER:$FTPPASS@$FTPPATH$FROMFILE

# остановить apache (раз информация потеряна, уже не страшно)
echo "[Stopped Apache Daemon]"
/etc/init.d/mysql stop

echo "[Unpach Files]"
cd $SRCDIR && tar xzpf $SRCDIR$FROMFILE

echo "[Stopped MySQL Daemon]"
/etc/init.d/mysql stop

echo "[Copy MySQL Datas]"
cd /var/lib/mysql/ && tar xpf $SRCDIR$DBFILENAME && cd -

echo "[Start MySQL Daemon]"
/etc/init.d/mysql start

# запустить apache
echo "[Start Apache Daemon]"
/etc/init.d/mysql start

# и подчистить за собой
echo "[Remove Backup-Files]"
rm $SRCDIR$FROMFILE
rm $SRCDIR$DBFILENAME

echo "Stop: [`date +%F--%H-%M`]"
